//*****************************************************************************
// AudioProc programm 
// Doynikov Andrew 
// 11.04.2008 ver: 2.0 
//*****************************************************************************
// LCD FUNCTIONS
//*****************************************************************************

#include <io.h>
#include <D:\Radio\cvavr\avr\pgmspace.h>
#include <delay.h>
#include <inttypes.h>
#include "lcd_lib.h"


//=============================================================================
void lcd(unsigned char p)
{ 
  LCD_PORT &= 0xF0; LCD_PORT |= (p >> 4);
  delay_ms(1);
  LCD_PORT &= ~_BV(LCD_EN);
  delay_ms(1);
  LCD_PORT |= _BV(LCD_EN);
  LCD_PORT &= 0xF0; LCD_PORT |= (p & 0x0F);
  delay_ms(1);
  LCD_PORT &= ~_BV(LCD_EN);
  delay_ms(1);
}                
//=============================================================================
void lcd_com(unsigned char p)
{
  LCD_PORT &= ~_BV(LCD_RS);
  LCD_PORT |= _BV(LCD_EN);
  lcd(p);
}
//=============================================================================
void lcd_dat(unsigned char p)
{
  LCD_PORT |= _BV(LCD_RS) | _BV(LCD_EN);
  lcd(p);
}
//=============================================================================
void lcd_init(void)
{
  _delay_ms(200);
  lcd_com(0x33);
  _delay_ms(20);
  lcd_com(0x32);
  lcd_com(0x28);
  lcd_com(0x08);
  lcd_com(0x01);
  _delay_ms(50);
  lcd_com(0x06);
  lcd_com(0x0C);

}
//=============================================================================
//=============================================================================
void lcd_puts(unsigned char *data)
{
  while(*data) lcd_dat(*(data++));
}
//=============================================================================
void lcd_clear(void)
{
  lcd_com(1<<LCD_CLR);
  _delay_ms(100);
}
//=============================================================================
void lcd_home(void)
{
  lcd_com(1<<LCD_HOME);
}
//=============================================================================
void lcd_cursor_ON(void) 
{
  lcd_com(0x0E);
}
//=============================================================================
void lcd_cursor_ON_blink(void)
{
  lcd_com(0x0F);
}
//=============================================================================
void lcd_cursor_OFF(void)
{
  lcd_com(0x0C);
}
//=============================================================================
void lcd_definechar(const uint8_t *pc,uint8_t char_code)
{
  uint8_t a, pcc;
  uint16_t i;
  a=(char_code<<3)|0x40;
  for (i=0; i<8; i++) {
    pcc=pgm_read_byte(&pc[i]);
	lcd_com(a++);
	lcd_dat(pcc);
  }
}
//=============================================================================
void lcd_clear2str(void)
{
  unsigned char i;
  lcd_com(0xC0);
  for (i=0; i<16; i++) {
    lcd_dat(' ');
  }
}
//=============================================================================
// END
//=============================================================================
